<script lang="ts">
  import { slide } from 'svelte/transition';
  import type { NavLink, NavTab } from '$lib/interfaces/navigation.interface';
  import { isNavLink } from '../../interfaces/navigation.interface.js';
  import { isAuthenticated, authTokenParsed } from '$stores/authStore';
  import { shouldDisplay } from '$lib/components/layout/data/nav-tabs';
  import { Button, Dropdown, DropdownItem } from "flowbite-svelte";

  export let navTab: NavTab | NavLink;

  let isOpen = false;

  const toggle = () => (isOpen = !isOpen);
</script>

{#if isNavLink(navTab)}
  <a class="hover:text-cyber-blue-500" href={navTab.href} on:click>
    <button class="flex justify-between items-center text-2xl text-left text-cyber-blue-900 px-8 py-4">
      {navTab.label}
    </button>
  </a>
{:else}
  <button
    on:click={toggle}
    aria-expanded={isOpen}
    class="flex justify-between items-center text-2xl text-left text-cyber-blue-900 px-8 py-4">
    {navTab.label}
    <svg
      xmlns="http://www.w3.org/2000/svg"
      class="h-6 w-6 ml-1 duration-150"
      fill="none"
      viewBox="0 0 24 24"
      stroke="currentColor"
      stroke-width="2"
      transform={isOpen ? 'rotate(-180)' : 'rotate(0)'}>
      <path stroke-linecap="round" stroke-linejoin="round" d="M19 9l-7 7-7-7" />
    </svg>
  </button>
  {#if isOpen}
    <ul transition:slide={{ duration: 500 }}>
      {#key $authTokenParsed}
        {#each navTab.links as link}
          {#if shouldDisplay(link, $isAuthenticated, $authTokenParsed)}
            <li>
              <Button
                color="none"
                data-umami-event="Navbar Link"
                data-umami-event-label="{link.label}"
                data-umami-event-href="{link.href}"
                data-umami-event-target="{link.target}"
                href={link.href}
                class="text-xl px-12 py-4 text-cyber-blue-900 hover:text-cyber-blue-500"
              >
                {link.label}
              </Button>
            </li>
          {/if}
        {/each}
      {/key}
    </ul>
  {/if}
{/if}
